<template>
  <div class="gpa-inventory">
    <div v-show="$route.name === 'inventory' || $largerThan('medium')" class="gpa-inventory__panel">
      <rui-tabs>
        <rui-button :active="visibleTab === 'patches'" @click="selectedTab = 'patches'">{{ $t('js.inventory.panel.patches') }}</rui-button>
        <rui-button :active="visibleTab === 'elements'" @click="selectedTab = 'elements'">{{ $t('js.inventory.panel.elements') }}</rui-button>
      </rui-tabs>

      <rui-search-form v-model="search" class="-pd" />

      <gpa-elements-inventory-menu v-if="visibleTab === 'elements'"
                                   class="gpa-inventory__panel__content"
                                   route-name="inventory-element-observations"
                                   base-route-name="inventory-element"
                                   :elements="filteredElements" />
      <div v-if="visibleTab === 'patches'" class="gpa-inventory__panel__content">
        <rui-toolbar class="-mbd">
          <template #right>
            <rui-help-button :content="$t('js.patches.help.virtual_patches')" />
          </template>
          <rui-button :caption="$t('js.patches.new_virtual_patch')"
                      icon="plus"
                      variant="creative"
                      block
                      @click="showNewPatchForm = true" />
        </rui-toolbar>
        <rui-empty v-if="filteredPatches.length === 0" class="-md" :content="$t('js.inventory.no_patch_to_display')" inline />
        <rui-list-item v-for="patch in filteredPatches"
                       :key="patch.id"
                       :to="{name: 'inventory-patch-elements', params: { patchId: patch.id }}"
                       :active="$route.name.includes('inventory-patch') && parseInt($route.params?.patchId, 10) === patch.id"
                       :caption="patch.displayName"
                       :icon="geometryIcon(patch.geometryType)" />
      </div>
    </div>
    <div v-show="$route.name !== 'inventory' || $largerThan('medium')" class="gpa-inventory__view">
      <router-view />
    </div>
  </div>

  <rui-modal v-if="showNewPatchForm"
             :caption="$t('js.patches.form.title.create_virtual')"
             :acceptable="false"
             no-footer
             @close="showNewPatchForm=false">
    <gpa-patch-form @cancel="showNewPatchForm = false" @saved="showNewPatchForm=false" />
  </rui-modal>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiSearchForm from '@experiments-labs/rise_ui/src/components/Form/SearchForm.vue'
import RuiHelpButton from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButton.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiModal from '@experiments-labs/rise_ui/src/components/Modal/Modal.vue'
import RuiTabs from '@experiments-labs/rise_ui/src/components/Tabs/Tabs.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import GpaElementsInventoryMenu from '../Elements/_InventoryMenu.vue'
import { geometryIcon } from '../../../../shapeIcons'
import GpaPatchForm from '../Patches/_Form.vue'

/**
 * @typedef {import('../../../../classes/models/Element')}  Element
 * @typedef {import('../../../../classes/models/Patch')}    Patch
 */

export default {
  name: 'GpaInventoryLayout',
  components: { RuiHelpButton, RuiModal, RuiListItem, RuiEmpty, RuiToolbar, RuiSearchForm, RuiButton, RuiTabs, GpaElementsInventoryMenu, GpaPatchForm },
  data () {
    return {
      /** Manually selected tab */
      selectedTab: this.$route.query?.show_tab,
      /** Whether to display the form to create a patch */
      showNewPatchForm: false,
      /** Search term to filter lists */
      search: '',
    }
  },
  computed: {
    /** @returns {Patch[]} List of patches */
    patches () { return this.$store.getters.patches },

    /** @returns {Element[]} List of single elements on map */
    elements () { return this.$store.getters.pointElements },

    /** @returns {string} Lowercased search term */
    searchTerm () { return this.search.toLocaleLowerCase() },

    /** @returns {Element[]} List of single elements matching the search */
    filteredElements () {
      if (this.searchTerm === '') return this.elements

      return this.elements.filter(entry => entry.displayName.toLocaleLowerCase().includes(this.searchTerm))
    },
    /** @returns {Patch[]} List of patches matching the search */
    filteredPatches () {
      if (this.searchTerm === '') return this.patches

      return this.patches.filter(entry => entry.displayName.toLocaleLowerCase().includes(this.searchTerm))
    },

    /** @returns {string} Selected tab depending on the route or manual selection */
    visibleTab () {
      if (this.selectedTab) return this.selectedTab

      if (this.$route.name.includes('inventory-element')) return 'elements'

      return 'patches'
    },
  },
  methods: {
    geometryIcon,
  },
  created () {
    this.$onBus('destroyed-element', (element) => {
      if (this.$route.name.includes('inventory-element') && parseInt(this.$route.params.elementId, 10) === element.id) {
        this.$router.push({ name: 'inventory', query: { show_tab: 'elements' } })
      }
    })
    this.$onBus('destroyed-patch-element', (element) => {
      if (this.$route.name.includes('inventory-patch-element') && parseInt(this.$route.params.elementId, 10) === element.id) {
        this.$router.push({ name: 'inventory-patch-elements', params: { patchId: this.$route.params.patchId } })
      }
    })
    this.$onBus('destroyed-patch', (patch) => {
      if (this.$route.name.includes('inventory-patch') && parseInt(this.$route.params.patchId, 10) === patch.id) {
        this.$router.push({ name: 'inventory', query: { show_tab: 'patches' } })
      }
    })
  },
}
</script>

<style lang="scss" src="./_InventoryLayout.scss" />
